// Tratamento de Exceção
#include <stdexcept>
#include <iostream>
using namespace std;

void f( int i ) throw (runtime_error, int ) {
    if( i < 0 )
        throw runtime_error( "Exceção" );
    else
        throw 45;
}
void g( int i ) throw (runtime_error ){
    try {
        f( i );
    } catch(runtime_error e) {
        cout << "g(): " << e.what() << endl;
        throw runtime_error( "Exceção g()" );
    } catch( string e ) {
        cout << e << endl;
    } catch( int v ) {
        cout << "v = " << v << endl;
    } catch( ... ) {
        cout << "Erro desconhecido" << endl;
    }
    
}
int main() {
    try {
        cout << "BEGIN TRY BLOCK" << endl;
        g( 0 );
        cout << "END   TRY BLOCK" << endl;
    } catch( runtime_error X ) {
        cout << X.what() << endl; 
    } catch( int v ) {
        cout << "v = " << v << endl;
    }
}


